OpenMPI 0.1.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Data Structures | Typedefs | Functions
Module for thumbnail generation.

: More...

## Data Structures
struct | OTFAUX_Thumbnail_Data

## Typedefs
typedef struct OTFAUX_Thumbnail_Context | OTFAUX_Thumbnail_Context
| Opaque type for using the thumbnail module. More...

## Functions
OTFAUX_Thumbnail_Context * | OTFAUX_Thumbnail_create (uint64_t minTime, uint64_t maxTime, uint32_t width)
| Create a context for thumbnail generation. More...
void | OTFAUX_Thumbnail_destroy (OTFAUX_Thumbnail_Context *tn_context)
| Destroy a context previously created with OTFAUX_Thumbnail_Create. More...
void | OTFAUX_Thumbnail_declareProcess (OTFAUX_Thumbnail_Context *tn_context, uint64_t process)
| Declares that the process process should be handled by this context. More...
void | OTFAUX_Thumbnail_handleEnter (OTFAUX_Thumbnail_Context *tn_context, uint64_t timestamp, uint64_t process, uint32_t function)
| Declare that the process process has entered the fucntion function at timestamp timestamp. More...
void | OTFAUX_Thumbnail_handleLeave (OTFAUX_Thumbnail_Context *tn_context, uint64_t timestamp, uint64_t process)
| Declare that the process process has left the current fucntion at timestamp timestamp. More...
uint32_t | OTFAUX_Thumbnail_getSize (OTFAUX_Thumbnail_Context *context, uint64_t process)
| Get the number of entries for the process process. More...
int | OTFAUX_Thumbnail_getData (OTFAUX_Thumbnail_Context *context, uint64_t process, OTFAUX_Thumbnail_Data *data)
| Get the collected thumbnail data for process process. More...

## Detailed Description

:

ctx = OTFAUX_Thumbnail_Create(minTime, maxTime, 1024);

announce all interesting processes: OTFAUX_Thumbnail_declareProcess(ctx, ...);

repeatedly call for interesting processes: OTFAUX_Thumbnail_handleEnter(ctx, ...); OTFAUX_Thumbnail_handleLeave(ctx, ...);

at end, for all processes: OTFAUX_ThumbnailData td; OTFAUX_Thumbnail_getData(ctx, process, &td); .. do something with td.start_pixel and td.function ..

OTFAUX_Thumbnail_Destroy(ctx);

## Typedef Documentation

typedef struct OTFAUX_Thumbnail_Context OTFAUX_Thumbnail_Context

Opaque type for using the thumbnail module.

## Function Documentation

OTFAUX_Thumbnail_Context* OTFAUX_Thumbnail_create | ( | uint64_t | minTime,
|  | uint64_t | maxTime,
|  | uint32_t | width
| ) |  |

Create a context for thumbnail generation.

Parameters

  minTime | Minimum timestamp of the trace file.
  maxTime | Maximum timestamp of the trace file.
  width | The width in pixels of the thumbnail.

Returns
  The context.

void OTFAUX_Thumbnail_declareProcess | ( | OTFAUX_Thumbnail_Context * | tn_context,
|  | uint64_t | process
| ) |  |

Declares that the process process should be handled by this context.

Parameters

  tn_context | The context.

void OTFAUX_Thumbnail_destroy | ( | OTFAUX_Thumbnail_Context * | tn_context | ) |

Destroy a context previously created with OTFAUX_Thumbnail_Create.

Parameters

  tn_context | The context.

References OTFAUX_Thumbail_Process::function_stack, OTFAUX_Thumbail_Process::next, and OTFAUX_Thumbnail_Context::processes.

int OTFAUX_Thumbnail_getData | ( | OTFAUX_Thumbnail_Context * | context,
|  | uint64_t | process,
|  | OTFAUX_Thumbnail_Data * | data
| ) |  |

Get the collected thumbnail data for process process.

Parameters

  tn_context | The context.
  process | The process.
  data | Pointer to storage where the data will be stored into.
  size | Pointer to storage where the size will be stored into.
  1 | on success.

uint32_t OTFAUX_Thumbnail_getSize | ( | OTFAUX_Thumbnail_Context * | context,
|  | uint64_t | process
| ) |  |

Get the number of entries for the process process.

Parameters

  tn_context | The context.
  The | size.

void OTFAUX_Thumbnail_handleEnter | ( | OTFAUX_Thumbnail_Context * | tn_context,
|  | uint64_t | timestamp,
|  | uint64_t | process,
|  | uint32_t | function
| ) |  |

Declare that the process process has entered the fucntion function at timestamp timestamp.

This function needs to be called in monotonically increasing timestamp order.

Parameters

  tn_context | The context.
  timestamp | The timestamp.
  process | The process.
  function | The function.

References OTFAUX_Thumbail_Process::function_stack.

void OTFAUX_Thumbnail_handleLeave | ( | OTFAUX_Thumbnail_Context * | tn_context,
|  | uint64_t | timestamp,
|  | uint64_t | process
| ) |  |

Declare that the process process has left the current fucntion at timestamp timestamp.

This function needs to be called in monotonically increasing timestamp order.

Parameters

  tn_context | The context.
  timestamp | The timestamp.
  process | The process.